<?php

// ##########################################################################
// #                       Thumbnail Creator                                #
// ##########################################################################
// # By: Darin Gilchrist                                                    #
// # 01/03/2009                                                             #
// #                                                                        #
// # This software is FREEWARE but not to be sold, re-packaged, or modified #
// # for commercial use without permission from the creator.                #
// ##########################################################################
// # Requirements:                                                          #
// # - PHP 5 minimum. (Not tested on other versions)                        #
// # - GD Library 2.0                                                       #
// ##########################################################################

$xh_cacheThumbs = "false";					// If you have a slow CPU, you can cache the thumbnails. Older thumbnails will be cleaned up if this is disabled.
$xh_thumbDropsh = "true";					// Enable thumbnail drop shadow. Be sure to set the color of your background below.
$xh_bgColor		= "EEEEEE"; 				// Background color for thumbnail, typically same color as page.
$xh_thumbBorder = "true";					// Enable thumbnail 1px border.
$xh_borderColor = "666666";					// Color for thumbnail border.
$xh_thumbMargin	= "4";						// Define width of white margin around image.
$xh_thumbZoom	= "2";						// Define zoom factor for thumbnail generation. (1-4)

$xh_maxFileSize = "1500000";				// Define file size limit for thumbnail generation - can help some slow CPUs.
$xh_thumbWidth	= "150";					// Thumbnail width.
$xh_thumbHeight = "100";					// Thumbnail height.
$xh_thumbWatermk = "";						// Add optional watermark to thumbs.

$pic    = $xh_serverGalleryPath . $_GET['pic'];
list($width_orig, $height_orig) = getimagesize($pic);				// Get dimensions of original image.
$pic_th = $pic . ".th";

if (filesize($pic) > $xh_maxFileSize)								// Dont play with files too big
{
	header("Content-type: image/gif");
	$im = imagecreatetruecolor($xh_thumbWidth, $xh_thumbHeight);
	$textcolor = imagecolorallocate($im, 255, 0, 0);
	imagestring($im, 2, 54, 42, "Too big!", $textcolor);
	if ($xh_thumbDropsh == "true")
	{
		$im = dropshad($im);
	}
	imagegif($im);
}
else if ((is_file("$pic")) && (preg_match("/\.gif$/i",$pic)))			// Depending on file type...
{
	header("Content-type: image/gif");									// Insert header info
	if (is_file($pic_th))												// If thumb exists, show it
	{
		$im_th = imagecreatefromgif($pic_th);							// Set up picture workspace
		imagegif($im_th);
	}
	else																// If not, create thumbnail
	{
		$im = imagecreatefromgif($pic);									// Set up picture workspace
		$im_th = resizemyimage($im);	// Go to function to resize
		$textcolor = imagecolorallocate($im_th, 128, 128, 128);
		imagestring($im_th, 0, 1, 1, $xh_thumbWatermk, $textcolor);		// Add "watermark"
		imagegif($im_th);												// Output image to browser
	}

	if ($xh_cacheThumbs == "true")										// Output image to file
	{
		imagegif($im_th, $pic_th);
	}
	else if (is_file($pic_th))
	{
		unlink($pic_th);
	}
}
else if ((is_file("$pic")) && (preg_match("/\.jpg|\.jpeg$/i",$pic)) )
{
	header("Content-type: image/jpeg");									// Insert header info
	if (is_file($pic_th))												// If thumb exists, show it
	{
		$im_th = imagecreatefromjpeg($pic_th);							// Set up picture workspace
		imagejpeg($im_th);
	}
	else																// If not, create thumbnail
	{
		$im = imagecreatefromjpeg($pic);								// Set up picture workspace
		$im_th = resizemyimage($im);	// Go to function to resize
		$textcolor = imagecolorallocate($im_th, 128, 128, 128);
		imagestring($im_th, 0, 1, 1, $xh_thumbWatermk, $textcolor);		// Add "watermark"
		imagejpeg($im_th, null, 80);									// Output image to browser
	}

	if ($xh_cacheThumbs == "true")										// Output image to file
	{
		imagejpeg($im_th, $pic_th);
	}
	else if (is_file($pic_th))
	{
		unlink($pic_th);
	}
}
else if ((is_file("$pic")) && (preg_match("/\.png$/i",$pic)))
{
	$im = imagecreatefrompng($pic);										// Set up picture workspace
	if (is_file($pic_th))												// If thumb exists, show it
	{
		$im_th = imagecreatefrompng($pic_th);							// Set up picture workspace
		imagepng($im_th);
	}
	else																// If not, create thumbnail
	{
		$im_th = resizemyimage($im);	// Go to function to resize
		$textcolor = imagecolorallocate($im_th, 128, 128, 128);
		imagestring($im_th, 0, 1, 1, $xh_thumbWatermk, $textcolor);		// Add "watermark"
		imagepng($im_th);												// Output image to browser
	}

	if ($xh_cacheThumbs == "true")										// Output image to file
	{
		imagepng($im_th, $pic_th);
	}
	else if (is_file($pic_th))
	{
		unlink($pic_th);
	}
}
else if (is_file("$pic"))
{
	echo "File type not supported.<BR>";
}
else
{
	echo "File \"$pic\" not found.<BR>";
}

function resizemyimage($im)		// Custom resizing function.
{
	global $xh_thumbWidth;
	global $xh_thumbHeight;
	global $xh_thumbDropsh;
	global $xh_thumbZoom;
	global $xh_thumbBorder;
	global $xh_thumbMargin;
	global $xh_bgColor;
	global $xh_borderColor;
	global $width_orig;
	global $height_orig;

	$start_pos_x = ($width_orig*($xh_thumbZoom/10));
	$start_pos_y = ($height_orig*($xh_thumbZoom/10));

	if ($height_orig >= $width_orig)
	{
		$grab_width = $width_orig - (2*$start_pos_x);
		$ratio = $xh_thumbWidth/$xh_thumbHeight;
		$grab_height = $grab_width/$ratio;
	}
	else
	{
		$grab_height = $height_orig - (2*$start_pos_y);
		$ratio = $xh_thumbHeight/$xh_thumbWidth;
		$grab_width = $grab_height/$ratio;
	}

	$im_th = imagecreatetruecolor($xh_thumbWidth, $xh_thumbHeight);								// Create new image space.
	imagefill($im_th, 0, 0, ImageColorAllocate($im_th, 255, 255, 255));

	imagecopyresampled($im_th, $im, $xh_thumbMargin, $xh_thumbMargin, $start_pos_x, $start_pos_y, $xh_thumbWidth-($xh_thumbMargin*2), $xh_thumbHeight-($xh_thumbMargin*2), $grab_width, $grab_height);	// Re-sample new image

	if ($xh_thumbBorder == "true")
	{
		if ($xh_borderColor == "")
		{
			$xh_borderColor = "333333";
		}
		$r = hexdec(substr($xh_borderColor, 0, 2));
		$g = hexdec(substr($xh_borderColor, 2, 2));
		$b = hexdec(substr($xh_borderColor, 4, 2));
		imagerectangle($im_th, 0, 0, $xh_thumbWidth-1, $xh_thumbHeight-1, ImageColorAllocate($im_th, $r, $g, $b));
	}

	if ($xh_thumbDropsh == "true")
	{
		$im_th = dropshad($im_th);
	}

	return $im_th;
	imagedestroy($im);
}

function dropshad($im_th)																		// Add drop shadow
{
	global $xh_thumbWidth;
	global $xh_thumbHeight;
	global $xh_bgColor;

	$im_thdrop = imagecreatetruecolor($xh_thumbWidth+5, $xh_thumbHeight+5);						// Make new thumbnail area

	if ($xh_bgColor == "")
	{
		$xh_bgColor = "FFFFFF";
	}
	$r = hexdec(substr($xh_bgColor, 0, 2));
	$g = hexdec(substr($xh_bgColor, 2, 2));
	$b = hexdec(substr($xh_bgColor, 4, 2));

	$shadow1 = ImageColorAllocate($im_thdrop, ($r-160), ($g-160), ($b-160));
	$shadow2 = ImageColorAllocate($im_thdrop, ($r-120), ($g-120), ($b-120));
	$shadow3 = ImageColorAllocate($im_thdrop, ($r-80), ($g-80), ($b-80));						// Generate colors
	$shadow4 = ImageColorAllocate($im_thdrop, ($r-40), ($g-40), ($b-40));
	$backgrd = ImageColorAllocate($im_thdrop, $r, $g, $b);

	$red = ImageColorAllocate($im_thdrop, 255, 0, 0);

	imagefill($im_thdrop, 0, 0, $backgrd);														// Fill background of thumbnail area
	imagecopymerge($im_thdrop, $im_th, 0, 0, 0, 0, $xh_thumbWidth, $xh_thumbHeight, 100);		// Plop thumbnail on top of area

	imageline($im_thdrop, 3, $xh_thumbHeight, $xh_thumbWidth, $xh_thumbHeight, $shadow1);		// Horizontal shadow line
	imageline($im_thdrop, $xh_thumbWidth, 3, $xh_thumbWidth, $xh_thumbHeight, $shadow1);		// Vertical shadow line
	imagesetpixel($im_thdrop, 3, $xh_thumbHeight+0, $shadow3);									// Extra pixels to soften things up
	imagesetpixel($im_thdrop, $xh_thumbWidth+0, 3, $shadow3);
	imagesetpixel($im_thdrop, $xh_thumbWidth+0, $xh_thumbHeight+0, $shadow2);

	imageline($im_thdrop, 4, $xh_thumbHeight+1, $xh_thumbWidth+1, $xh_thumbHeight+1, $shadow2);
	imageline($im_thdrop, $xh_thumbWidth+1, 4, $xh_thumbWidth+1, $xh_thumbHeight+1, $shadow2);
	imagesetpixel($im_thdrop, 4, $xh_thumbHeight+1, $shadow3);
	imagesetpixel($im_thdrop, $xh_thumbWidth+1, 4, $shadow3);
	imagesetpixel($im_thdrop, $xh_thumbWidth+1, $xh_thumbHeight+1, $shadow3);

	imageline($im_thdrop, 5, $xh_thumbHeight+2, $xh_thumbWidth+2, $xh_thumbHeight+2, $shadow3);
	imageline($im_thdrop, $xh_thumbWidth+2, 5, $xh_thumbWidth+2, $xh_thumbHeight+2, $shadow3);
	imagesetpixel($im_thdrop, 5, $xh_thumbHeight+2, $shadow4);
	imagesetpixel($im_thdrop, $xh_thumbWidth+2, 5, $shadow4);
	imagesetpixel($im_thdrop, $xh_thumbWidth+2, $xh_thumbHeight+2, $shadow4);

	imageline($im_thdrop, 6, $xh_thumbHeight+3, $xh_thumbWidth+3, $xh_thumbHeight+3, $shadow4);
	imageline($im_thdrop, $xh_thumbWidth+3, 6, $xh_thumbWidth+3, $xh_thumbHeight+3, $shadow4);
	imagesetpixel($im_thdrop, 6, $xh_thumbHeight+3, $backgrd);
	imagesetpixel($im_thdrop, $xh_thumbWidth+3, 6, $backgrd);
	imagesetpixel($im_thdrop, $xh_thumbWidth+3, $xh_thumbHeight+3, $backgrd);

	return $im_thdrop;
}


?>